#ifndef incl_marqu_s
#define incl_marqu_s
#include "cvar.h"


FUNCTION_DECL ( static void keybd_interrupt , (int errno));

FUNCTION_DECL ( static void calculate_new_position, (
   double *dp,
   double *mparam));

FUNCTION_DECL (static void compute_error_vector, (
   double *mparams,	/* The parameters used for the computation */
   double *dy,		/* The error vector */
   int nrows, 		/* Number of elements in mparams */
   int ncols));

FUNCTION_DECL (static double calculate_error, (double *del));

FUNCTION_DECL (static int compute_covariance, (
   double **dyda, 		/* Jacobian */
   double *dy,			/* Error vector */
   double **weight,		/* Weight matrix or vector */
   BOOLEAN diag,		/* Tells whether weight matrix is diagonal */
   int nrows, int ncols,	/* Dimensions of the Jacobian matrix */
   double **covar		/* Returned covariance matrix.  Must already be
				 * allocated */
   ));

FUNCTION_DECL (static void mrqcof, (
   double **weight, 
   double **alpha, 
   double *beta, 
   double **dyda, 
   double *dy,
   int nrows, 
   int ncols,
   int diag));

FUNCTION_DECL (static void compute_jacobian, (
   double *mparam,
   double **dyda,
   int nrows, int ncols));

FUNCTION_DECL (static double marquardt_go, ());

FUNCTION_DECL (double marquardt, (Marquardt_info *mar));

FUNCTION_DECL (void marquardt_debug, (
   double **alpha, 
   double *beta));

#endif
